Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.4.2
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.io
Class PushbackInputStream

    java.lang.Object
      java.io.InputStream
          java.io.FilterInputStream
              java.io.PushbackInputStream

public class PushbackInputStream
extends FilterInputStream

A `PushbackInputStream` adds functionality to another input stream, namely the ability to "push back" or "unread" one byte. This is useful in situations where it is convenient for a fragment of code to read an indefinite number of data bytes that are delimited by a particular byte value; after reading the terminating byte, the code fragment can "unread" it, so that the next read operation on the input stream will reread the byte that was pushed back. For example, bytes representing the characters constituting an identifier might be terminated by a byte representing an operator character; a method whose job is to read just an identifier can read until it sees the operator and then push the operator back to be re-read.

Since:
  JDK1.0

Field Summary
`protected byte[]` | `buf` The pushback buffer.
`protected int` | `pos` The position within the pushback buffer from which the next byte will be read.

Fields inherited from class java.io.FilterInputStream
`in`

Constructor Summary
`PushbackInputStream(InputStream in)` Creates a `PushbackInputStream` and saves its argument, the input stream `in`, for later use.
`PushbackInputStream(InputStream in, int size)` Creates a `PushbackInputStream` with a pushback buffer of the specified `size`, and saves its argument, the input stream `in`, for later use.

Method Summary
`int` | `available()` Returns the number of bytes that can be read from this input stream without blocking.
`void` | `close()` Closes this input stream and releases any system resources associated with the stream.
`boolean` | `markSupported()` Tests if this input stream supports the `mark` and `reset` methods, which it does not.
`int` | `read()` Reads the next byte of data from this input stream.
`int` | `read(byte[] b, int off, int len)` Reads up to `len` bytes of data from this input stream into an array of bytes.
`long` | `skip(long n)` Skips over and discards `n` bytes of data from this input stream.
`void` | `unread(byte[] b)` Pushes back an array of bytes by copying it to the front of the pushback buffer.
`void` | `unread(byte[] b, int off, int len)` Pushes back a portion of an array of bytes by copying it to the front of the pushback buffer.
`void` | `unread(int b)` Pushes back a byte by copying it to the front of the pushback buffer.

Methods inherited from class java.io.FilterInputStream
`mark, read, reset`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### buf

    protected byte[] buf

  The pushback buffer.

  Since:
    JDK1.1

### pos

    protected int pos

  The position within the pushback buffer from which the next byte will be read. When the buffer is empty, `pos` is equal to `buf.length`; when the buffer is full, `pos` is equal to zero.

  Since:
    JDK1.1

Constructor Detail

### PushbackInputStream

    public PushbackInputStream(InputStream in,
                               int size)

  Creates a `PushbackInputStream` with a pushback buffer of the specified `size`, and saves its argument, the input stream `in`, for later use. Initially, there is no pushed-back byte (the field `pushBack` is initialized to `-1`).

Parameters:
  `in` - the input stream from which bytes will be read.
  `size` - the size of the pushback buffer.
Throws:
  `IllegalArgumentException` - if size is <= 0
Since:
  JDK1.1

### PushbackInputStream

    public PushbackInputStream(InputStream in)

  Creates a `PushbackInputStream` and saves its argument, the input stream `in`, for later use. Initially, there is no pushed-back byte (the field `pushBack` is initialized to `-1`).

Parameters:
  `in` - the input stream from which bytes will be read.

Method Detail

### read

    public int read()
             throws IOException

  Reads the next byte of data from this input stream. The value byte is returned as an `int` in the range `0` to `255`. If no byte is available because the end of the stream has been reached, the value `-1` is returned. This method blocks until input data is available, the end of the stream is detected, or an exception is thrown.

  This method returns the most recently pushed-back byte, if there is one, and otherwise calls the `read` method of its underlying input stream and returns whatever value that method returns.

  Overrides:
    `read` in class `FilterInputStream`
  Returns:
    the next byte of data, or `-1` if the end of the stream has been reached.
  Throws:
    `IOException` - if an I/O error occurs.
  See Also:
    `InputStream.read()`

### read

    public int read(byte[] b,
                    int off,
                    int len)
             throws IOException

  Reads up to `len` bytes of data from this input stream into an array of bytes. This method first reads any pushed-back bytes; after that, if fewer than than `len` bytes have been read then it reads from the underlying input stream. This method blocks until at least 1 byte of input is available.

  Overrides:
    `read` in class `FilterInputStream`
  Parameters:
    `b` - the buffer into which the data is read.
    `off` - the start offset of the data.
    `len` - the maximum number of bytes read.
  Returns:
    the total number of bytes read into the buffer, or `-1` if there is no more data because the end of the stream has been reached.
  Throws:
    `IOException` - if an I/O error occurs.
  See Also:
    `InputStream.read(byte[], int, int)`

### unread

    public void unread(int b)
                throws IOException

  Pushes back a byte by copying it to the front of the pushback buffer. After this method returns, the next byte to be read will have the value `(byte)b`.

  Parameters:
    `b` - the `int` value whose low-order byte is to be pushed back.
  Throws:
    `IOException` - If there is not enough room in the pushback buffer for the byte.

### unread

    public void unread(byte[] b,
                       int off,
                       int len)
                throws IOException

  Pushes back a portion of an array of bytes by copying it to the front of the pushback buffer. After this method returns, the next byte to be read will have the value `b[off]`, the byte after that will have the value `b[off+1]`, and so forth.

  Parameters:
    `b` - the byte array to push back.
    `off` - the start offset of the data.
    `len` - the number of bytes to push back.
  Throws:
    `IOException` - If there is not enough room in the pushback buffer for the specified number of bytes.
  Since:
    JDK1.1

### unread

    public void unread(byte[] b)
                throws IOException

  Pushes back an array of bytes by copying it to the front of the pushback buffer. After this method returns, the next byte to be read will have the value `b[0]`, the byte after that will have the value `b[1]`, and so forth.

  Parameters:
    `b` - the byte array to push back
  Throws:
    `IOException` - If there is not enough room in the pushback buffer for the specified number of bytes.
  Since:
    JDK1.1

### available

    public int available()
                  throws IOException

  Returns the number of bytes that can be read from this input stream without blocking. This method calls the `available` method of the underlying input stream; it returns that value plus the number of bytes that have been pushed back.

  Overrides:
    `available` in class `FilterInputStream`
  Returns:
    the number of bytes that can be read from the input stream without blocking.
  Throws:
    `IOException` - if an I/O error occurs.
  See Also:
    `FilterInputStream.in`, `InputStream.available()`

### skip

    public long skip(long n)
              throws IOException

  Skips over and discards `n` bytes of data from this input stream. The `skip` method may, for a variety of reasons, end up skipping over some smaller number of bytes, possibly zero. If `n` is negative, no bytes are skipped.

  The `skip` method of `PushbackInputStream` first skips over the bytes in the pushback buffer, if any. It then calls the `skip` method of the underlying input stream if more bytes need to be skipped. The actual number of bytes skipped is returned.

  Overrides:
    `skip` in class `FilterInputStream`
  Parameters:
    `n` - the number of bytes to be skipped.
  Returns:
    the actual number of bytes skipped.
  Throws:
    `IOException` - if an I/O error occurs.
  Since:
    1.2
  See Also:
    `FilterInputStream.in`, `InputStream.skip(long n)`

### markSupported

    public boolean markSupported()

  Tests if this input stream supports the `mark` and `reset` methods, which it does not.

  Overrides:
    `markSupported` in class `FilterInputStream`
  Returns:
    `false`, since this class does not support the `mark` and `reset` methods.
  See Also:
    `InputStream.mark(int)`, `InputStream.reset()`

### close

    public void close()
               throws IOException

  Closes this input stream and releases any system resources associated with the stream.

  Overrides:
    `close` in class `FilterInputStream`
  Throws:
    `IOException` - if an I/O error occurs.
  See Also:
    `FilterInputStream.in`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.4.2
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Copyright 2003 Sun Microsystems, Inc. All rights reserved. Use is subject to license terms. Also see the documentation redistribution policy.